package fr.username404.snowygui.gui.feature

import fr.username404.snowygui.Snowy
import net.arikia.dev.drpc.DiscordEventHandlers
import net.arikia.dev.drpc.DiscordRichPresence
import net.minecraft.client.Minecraft
import net.arikia.dev.drpc.DiscordRPC as discord_rpc

@ButtonInfo(Category.MISC)
object DiscordRPC: ButtonImpl() {
    private val RPCHandlers: DiscordEventHandlers = DiscordEventHandlers.Builder().build()
    private val RichPresence: Lazy<DiscordRichPresence.Builder> = lazy { DiscordRichPresence
        .Builder("Playing Minecraft ${Minecraft.getInstance().launchedVersion}")
        .setDetails("Launched with ${Minecraft.getInstance().versionType}")
        .setBigImage("icon", "SnowyGUI")
    }
    override fun execAction() {
        if (toggled) discord_rpc.discordUpdatePresence(RichPresence.value.build())
        else discord_rpc.discordClearPresence()
    }
    init {
        try {
            discord_rpc.discordInitialize("839058922102849538", RPCHandlers, true)
            Runtime.getRuntime().addShutdownHook(Thread { discord_rpc.discordShutdown() })
        } catch (_: UnsatisfiedLinkError) {
            Snowy.logs.error("Could not initialize DiscordRPC because the needed libraries are not present on your operating system; the feature will therefore be disabled.")
            isDisabled = true
        }
    }
}